#include "fenetre.h"

bool fenetre::active=false;
bool fenetre::fullscreen=false;
bool fenetre::keys[259];
Carre3D *fenetre::objets=NULL;
GLint fenetre::ancSourisx=0;
GLint fenetre::ancSourisy=0;
GLint fenetre::sourisx=0;
GLint fenetre::sourisy=0;
GLint fenetre::sourisdx=0;
GLint fenetre::sourisdy=0;
HDC	fenetre::hDC;		// GDI device context
HGLRC fenetre::hRC;		// Rendering context
HWND fenetre::hWnd;		// Notre fenetre
HINSTANCE fenetre::hInstance;	// Notre application
double fenetre::time=0;
GLfloat fenetre::temps=0;

fenetre::fenetre(){
	hDC=NULL;
	hRC=NULL;
	hWnd=NULL;
	active=false;
	fullscreen=true;	// Fullscreen actif?
};

fenetre::~fenetre(){
};

void fenetre::init(Carre3D *obj){
	if (objets!=NULL){
		delete objets;
	};
	objets=obj;
};

void fenetre::initDessin(){
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //Efface le framebuffer et le depthbuffer  
	glMatrixMode(GL_MODELVIEW); 
	glLoadIdentity(); 
};

void fenetre::initGL(){
	glShadeModel(GL_SMOOTH);
	glClearColor(.2,.2,.2,1);							//Change la couleur du fond 
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
//	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_COLOR_MATERIAL);						//Active les couleurs des materiaux
	glEnable(GL_NORMALIZE);								//normalise les normales
	glEnable(GL_ALPHA_TEST); 							//Active le texturing 
//	glEnable(GL_TEXTURE_2D); 							//Active le texturing 
//	glEnable(GL_LIGHTING); 								// Active l'clairage 
//	glEnable(GL_LIGHT0); 								// Allume la lumire n1 
} 


void fenetre::dessineAxe(){
	glDisable(GL_LIGHTING);
	// dessine les axes
	glBegin(GL_LINES);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3i(1000,0,0); 
	glVertex3i(0,0,0);
	glVertex3f(1000.0,0.01,0.01); 
	glVertex3f(0,0.01,0.01); 
	glVertex3f(15,-2,0);
	glVertex3f(5,2,0); 
	glVertex3f(15,2,0);
	glVertex3f(5,-2,0);
	
	glColor3f(1.0f,1.0f,0.0f);
	glVertex3i(0,1000,0);
	glVertex3i(0,0,0);
	glVertex3f(0.01,1000.0,0.01);
	glVertex3f(0.01,0.0,0.01);
	glVertex3f(-2,15,0);
	glVertex3f(0,10,0); 
	glVertex3f(-2,5,0);
	glVertex3f(2,15,0);

	glColor3f(1.0f,0.0f,0.0f);
	glVertex3i(0,0,1000); 
	glVertex3i(0,0,0); 
	glVertex3f(0.01,0.01,1000.0); 
	glVertex3f(0.01,0.01,0.0); 
	glVertex3f(-2,0,15);
	glVertex3f(2,0,15); 
	glVertex3f(2,0,15);
	glVertex3f(-2,0,5);
	glVertex3f(-2,0,5);
	glVertex3f(2,0,5);
	glEnd();
	glEnable(GL_LIGHTING); 
};

void fenetre::dessiner()
{
	glDisable(GL_LIGHTING);
	glPushMatrix();
	if(objets!=NULL){
		
	glBegin(GL_QUADS);
	glColor3f(1.0f,1.0f,1.0f);
		glVertex3f(objets->getPoint(1).getVal(1),
			objets->getPoint(1).getVal(2),
			objets->getPoint(1).getVal(3)); 
		glVertex3f(objets->getPoint(2).getVal(1),
			objets->getPoint(2).getVal(2),
			objets->getPoint(2).getVal(3)); 
		glVertex3f(objets->getPoint(3).getVal(1),
			objets->getPoint(3).getVal(2),
			objets->getPoint(3).getVal(3)); 
		glVertex3f(objets->getPoint(4).getVal(1),
			objets->getPoint(4).getVal(2),
			objets->getPoint(4).getVal(3)); 
	
	glEnd();
	};
	glPopMatrix();
	fenetre::dessineAxe();
	SwapBuffers(hDC);
	glEnable(GL_LIGHTING); 
};


GLvoid fenetre::Redimension(GLsizei width, GLsizei height)// Redimentionne et initialise la fenetre opengl
{
	if (height==0)										// Empeche une division par 0
		height=1;

	glViewport(0,0,width,height);						// Reinitialise Viewport

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Calcule le ratio de la fenetre
	gluPerspective(22.5f,(GLfloat)width/(GLfloat)height,100.0f,3500.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}


GLvoid fenetre::FinGL()									// Ferme proprement la fenetre
{
	if (fullscreen)										// Si on est en fullscreen
	{
		ChangeDisplaySettings(NULL,0);					// Alors on revient au bureau
		ShowCursor(TRUE);								// On affiche le pointeur
	}

	if (hRC)											// A t'on un RC?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Peut on relacher le DC et le RC?
		{
			MessageBox(fenetre::hWnd,"relachement du DC et du RC echou.","ERREUR FERMETURE",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Peut on supprimer le RC?
		{
			MessageBox(fenetre::hWnd,"Suppression du RC impossible.","ERREUR FERMETURE",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Peut on supprimer le DC?
	{
		MessageBox(fenetre::hWnd,"Suppression du DC impossible.","ERREUR FERMETURE",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Peut on supprimer la fenetre?
	{
		MessageBox(fenetre::hWnd,"fermeture de la fenetre impossible.","ERREUR FERMETURE",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Peut on libere l'instance?
	{
		MessageBox(fenetre::hWnd,"liberation de l'instance impossible.","ERREUR FERMETURE",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}


LRESULT CALLBACK fenetre::WndProc(	HWND	hWnd,
							UINT	uMsg,
							WPARAM	wParam,
							LPARAM	lParam)
{
	switch (uMsg)									// Dispatche les messages de windows
	{
		case WM_KEYDOWN:							// Une touche est presse?
		{
			keys[wParam] = true;					// Si oui, on la marque  vrai
			return 0;
		}

		case WM_KEYUP:								// Une touche est relache?
		{
			keys[wParam] = false;					// Si oui, on la marque  faux
			return 0;
		}

		case WM_ACTIVATE:							// Une activation de la fenetre?
		{
			if (!HIWORD(wParam))					// Regarde si c'est une activation
			{
				active=true;
			}
			else
			{
				active=false;						// Ou une desactivation
			}

			return 0;
		}

		case WM_COMMAND:							// Intercepte les messages que j'ai defini
		{
			DWORD ThreadId;
			switch (wParam){
			case 1:
				if(Objet3D::charger()){//Objet3D le fichier a transformer...
					fenetre::init(Objet3D::getForme());
				};
				return 0;
				break;
			case 2:
				objets=NULL;
				return 0;
				break;
			case 3:
				MessageBox(NULL,"Vous ne savez pas encore faire a ;-)","Et non...",MB_OK);
				return 0;
				break;
			case 4:
				MessageBox(NULL,"Vous ne savez pas encore faire a ;-)","Et non...",MB_OK);
				return 0;
				break;
			case 5:
				MessageBox(NULL,"Vous ne savez pas encore faire a ;-)","Et non...",MB_OK);
				return 0;
				break;
			case 6:
				MessageBox(NULL,"Vous ne savez pas encore faire a ;-)","Et non...",MB_OK);
				return 0;
				break;
			case 7:
				MessageBox(NULL,"Vous ne savez pas encore faire a ;-)","Et non...",MB_OK);
				return 0;
				break;
			case 8:
				MessageBox(NULL,"Vous ne savez pas encore faire a ;-)","Et non...",MB_OK);
				return 0;
				break;
			
			default :
				return 0;
				break;
			};
		};

		case WM_SYSCOMMAND:							// Intercepte les messages systemes
		{
			switch (wParam)
			{
				case SC_SCREENSAVE:					// Economiseur d'ecran se declanche?
				case SC_MONITORPOWER:				// Economie d'energie se declanche?
				return true;							// Empeche d'arriver
			}
			break;
		}

		case WM_CLOSE:								// Doit on fermet la fenetre?
		{
			PostQuitMessage(0);						// Quitte l'appli
			return 0;
		}

		case WM_SIZE:								// Redimension de la fenetre?
		{
			Redimension(LOWORD(lParam),HIWORD(lParam));
			return 0;
		}
        case WM_LBUTTONDOWN:						//souris droite enfonc
        {
			keys[259] = true;						// Si oui, on la marque  vrai
			return 0;
        }
        break;

        case WM_LBUTTONUP:							//souris droite relache
        {
			keys[259] = false;						// Si oui, on la marque  vrai
			return 0;
        }

        case WM_MBUTTONDOWN:						//souris milieu enfonc
        {
			keys[258] = true;						// Si oui, on la marque  vrai
			return 0;
        }
        break;

        case WM_MBUTTONUP:							//souris milieu relache
        {
			keys[258] = false;						// Si oui, on la marque  vrai
			return 0;
        }
        break;

        case WM_RBUTTONDOWN:						//souris droite enfonc
        {
			keys[257] = true;						// Si oui, on la marque  vrai
			return 0;
        }
        break;

        case WM_RBUTTONUP:							//souris droite relache
        {
			keys[257] = false;						// Si oui, on la marque  faux
			return 0;
        }
        break;

        case WM_MOUSEMOVE:
        {
            sourisx = LOWORD (lParam);
            sourisy = HIWORD (lParam);

			sourisdx=ancSourisx-sourisx;
			sourisdy=ancSourisy-sourisy;

            ancSourisx = sourisx;
            ancSourisy = sourisy;
			return 0;
        }
        break;

	}

	// Passe les autres messages  DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}



/*	Creation de la fenetre Opengl. les parametres :							*
 *	title			- Titre de la fenetre									*
 *	width			- largeur de la fenetre									*
 *	height			- hauteur de la fenetre									*
 *	bits			- nombre de bit de la fenetre							*
 *	fullscreenflag	- En Fullscreen (TRUE) ou Fenetr (FALSE)				*/
 
BOOL fenetre::CreeGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;
	WNDCLASS	wc;
	DWORD		dwExStyle;
	DWORD		dwStyle;
	RECT		WindowRect;
	WindowRect.left=(long)0;
	WindowRect.right=(long)width;
	WindowRect.top=(long)0;
	WindowRect.bottom=(long)height;

	fullscreen=fullscreenflag;			// Met a jour l'info de fullscreen

	hInstance			= GetModuleHandle(NULL);				// Recupere l'instance de la fenetre
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redessine si modification de la taille ou de la position et garde un seul DC pour la fenetre.
	wc.lpfnWndProc		= (WNDPROC) fenetre::WndProc;			// fonction de traitement des messages
	wc.cbClsExtra		= 0;									
	wc.cbWndExtra		= 0;									
	wc.hInstance		= hInstance;							
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Icone par default
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Curseur par default
	wc.hbrBackground	= NULL;									// Pas de fond pour Opengl
	wc.lpszMenuName		= NULL;									// On ne veut pas de menu
	wc.lpszClassName	= "OpenGL";								// Nom de la fenetre

	if (!RegisterClass(&wc))									// Essaye de creer la class fenetre
	{
		MessageBox(fenetre::hWnd,"Impossible de cree la class fenetre....","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}
	
	if (fullscreen)												// Est on en plein ecran?
	{
		DEVMODE dmScreenSettings;
		EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&dmScreenSettings);
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth	= width;
		dmScreenSettings.dmPelsHeight	= height;
		dmScreenSettings.dmBitsPerPel	= bits;
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;
		dmScreenSettings.dmDisplayFrequency=70;

		// Essaye de faire les changements de rezo.  NOTE: CDS_FULLSCREEN permet d'enlever la bar demarrer
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// Si ce n'est pas reussi, on donne le choix d'essayer en fenetre
			if (MessageBox(fenetre::hWnd,"Le mode plein ecran n'est pas suport...\n essayer en mode fenetr?","Initialisation",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Fenetre choisi.  Fullscreen = FALSE
			}
			else
			{
				// Erreur, le programme ferme :
				MessageBox(fenetre::hWnd,"Erreur d'initialisation...","ERREUR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Si on est en plein ecran
	{
		dwExStyle=WS_EX_APPWINDOW;
		dwStyle=WS_POPUP;
		ShowCursor(FALSE);
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
		dwStyle=WS_OVERLAPPEDWINDOW;
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);

	// Cree la fenetre
	if (!(hWnd=CreateWindowEx(	dwExStyle,
								"OpenGL",							// Nom de la class
								title,								// Nom de la fenetre
								dwStyle |							// Style de la fenetre
								WS_CLIPSIBLINGS |
								WS_CLIPCHILDREN,
								0, 0,								// Position de la fenetre
								WindowRect.right-WindowRect.left,	// Calcule la largeur
								WindowRect.bottom-WindowRect.top,	// Calcule la hauteur
								NULL,
								NULL,
								hInstance,							// Instance
								NULL)))
	{
		FinGL();								// supprime le contexte
		MessageBox(fenetre::hWnd,"Creation de la fenetre echou.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	static	PIXELFORMATDESCRIPTOR pfd=	
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Taille du descripteur de fenetre
		1,											// Numero de version
		PFD_DRAW_TO_WINDOW |						// Le format sera pour une fenetre
		PFD_SUPPORT_OPENGL |						// Le format sera pour Opengl
		PFD_DOUBLEBUFFER,							// Le format sera en double buffering
		PFD_TYPE_RGBA,								// Le format sera en RGBA
		bits,										// Profondeur de couleur
		0, 0, 0, 0, 0, 0,
		0,
		0,
		0,
		0, 0, 0, 0,
		16,											// Z-Buffer
		0,											// Pas de Stencil Buffer
		0,											// Pas de buffer auxilliere
		PFD_MAIN_PLANE,	
		0,
		0, 0, 0	
	};
	
	if (!(hDC=GetDC(hWnd)))							// A t on un DC
	{
		FinGL();								// supprime le contexte
		MessageBox(fenetre::hWnd,"Ne peut pas creer de support OpenGL ...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))
	{
		FinGL();								// supprime le contexte
		MessageBox(fenetre::hWnd,"Ne trouve pas de format de pixel utilisable ...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))
	{
		FinGL();								// supprime le contexte
		MessageBox(fenetre::hWnd,"Ne peut pas utiliser le format de pixel ...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if (!(hRC=wglCreateContext(hDC)))
	{
		FinGL();								// supprime le contexte
		MessageBox(fenetre::hWnd,"Ne peut pas cree de context d'affichage ...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if(!wglMakeCurrent(hDC,hRC))
	{
		FinGL();								// supprime le contexte
		MessageBox(fenetre::hWnd,"Ne peut pas activer le context d'affichage ...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	ShowWindow(hWnd,SW_SHOW);						// affiche la fenetre
	SetForegroundWindow(hWnd);						// Met en priorit superieure
	SetFocus(hWnd);									// Redirige le clavier vers la fenetre
	initGL();
	Redimension(width, height);


	return TRUE;									// Success
}

void fenetre::initSouris(POINT* ptrPoint){
	SetCursorPos(ptrPoint->x,ptrPoint->y);
	ancSourisx=ptrPoint->x;
	ancSourisy=ptrPoint->y;
	sourisx=ptrPoint->x;
	sourisy=ptrPoint->y;
	sourisdx=0;
	sourisdy=0;
};
