
#ifndef __FENETRE
#define __FENETRE 1

#include <windows.h>		
#include <gl\gl.h>			
#include <gl\glu.h>			
#include <gl\glaux.h>	
#include "Deplacement.h"
#include "Objet3D.h"
#include "Carre3D.h"

DWORD WINAPI informations(LPVOID lpParam);
DWORD WINAPI choixaffiche(LPVOID lpParam);
DWORD WINAPI correspondance(LPVOID lpParam);

template<typename T>
std::string to_string( const T & Value )
{
    // utiliser un flux de sortie pour crer la chane
    std::ostringstream oss;
    // crire la valeur dans le flux
    oss << Value;
    // renvoyer une string
    return oss.str();
}


class fenetre{
private:
	static GLint ancSourisx;
	static GLint ancSourisy;
	static double time;
public:
	fenetre();
	~fenetre();
	static void init(Carre3D *);
	static void initDessin();
	static GLvoid Redimension(GLsizei, GLsizei);
	GLvoid FinGL();											// fermeture de la fenetre
	GLvoid initGL();										// initialisation d'opengl
	GLvoid dessiner();										// affiche la scene
	BOOL CreeGLWindow(char*, int, int, int, bool);			// cree une fenetre
	static LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration pour WndProc
	static void initSouris(POINT*);
	static void dessineAxe();
	static void actualiseTimer();
	
	static HDC			hDC;		// GDI device context
	static HGLRC		hRC;		// Rendering context
	static HWND		hWnd;		// Notre fenetre
	static HINSTANCE	hInstance;	// Notre application
	static bool	keys[259];	// Tableau des touches
	static bool	active;		// Fenetre active?
	static bool	fullscreen;	// Fullscreen actif?
	static GLint sourisx;
	static GLint sourisy;
	static GLint sourisdx;
	static GLint sourisdy;
	static GLfloat temps;
	static Carre3D *objets;
};

inline void fenetre::actualiseTimer(){
	temps=(GetTickCount()-time)* 0.001;
	time=GetTickCount();
};

#endif